/*     */ package com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.reportjobmodel;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.JSClientException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.Job;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.JobAlert;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.JobSource;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.JobTrigger;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.MailNotification;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.OutputFormat;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.RepositoryDestination;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.SimpleTrigger;
/*     */ import java.sql.Timestamp;
/*     */ import java.util.Set;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlElements;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.XmlTransient;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @XmlRootElement(name="jobModel")
/*     */ public class ReportJobModel
/*     */   extends Job
/*     */ {
/*     */   public static enum ReportJobSortType
/*     */   {
/*  51 */     NONE, 
/*  52 */     SORTBY_JOBID, 
/*  53 */     SORTBY_JOBNAME, 
/*  54 */     SORTBY_REPORTURI, 
/*  55 */     SORTBY_REPORTNAME, 
/*  56 */     SORTBY_REPORTFOLDER, 
/*  57 */     SORTBY_OWNER, 
/*  58 */     SORTBY_STATUS, 
/*  59 */     SORTBY_LASTRUN, 
/*  60 */     SORTBY_NEXTRUN;
/*     */     
/*     */     private ReportJobSortType() {}
/*     */   }
/*     */   
/*     */   @XmlElement(name="sourceModel")
/*  66 */   public ReportJobSourceModel getSource() { JobSource model = super.getSource();
/*  67 */     if (model == null) return null;
/*  68 */     if ((model instanceof ReportJobSourceModel)) return (ReportJobSourceModel)model;
/*  69 */     throw new JSClientException("Please use ReportJobSourceModel instead of JobSource in ReportJobModel class.");
/*     */   }
/*     */   
/*     */   public void setSource(JobSource source)
/*     */   {
/*  74 */     super.setSource(source);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   @XmlElements({@XmlElement(name="simpleTriggerModel", type=ReportJobSimpleTriggerModel.class), @XmlElement(name="calendarTriggerModel", type=ReportJobCalendarTriggerModel.class)})
/*     */   public JobTrigger getTrigger()
/*     */   {
/*  82 */     JobTrigger model = super.getTrigger();
/*  83 */     if (model == null) return null;
/*  84 */     if (((model instanceof ReportJobSimpleTriggerModel)) || ((model instanceof ReportJobCalendarTriggerModel))) {
/*  85 */       return model;
/*     */     }
/*  87 */     throw new JSClientException("Please useReportJobTriggerModel instead of JobTrigger in ReportJobModel class.");
/*     */   }
/*     */   
/*     */   public void setTrigger(JobTrigger trigger)
/*     */   {
/*  92 */     if (trigger == null) {
/*  93 */       super.setTrigger(null);
/*  94 */     } else if (((trigger instanceof ReportJobSimpleTriggerModel)) || ((trigger instanceof ReportJobCalendarTriggerModel))) {
/*  95 */       super.setTrigger(trigger);
/*     */     } else {
/*  97 */       if ((trigger instanceof SimpleTrigger)) {
/*  98 */         throw new JSClientException("Please use ReportJobSimpleTriggerModel instead of ReportJobSimpleTrigger in ReportJobModel class.");
/*     */       }
/* 100 */       throw new JSClientException("Please use ReportJobCalendarTriggerModel instead of ReportJobCalendarTrigger in ReportJobModel class.");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   @XmlElement(name="alertModel")
/*     */   public ReportJobAlertModel getAlert()
/*     */   {
/* 108 */     JobAlert model = super.getAlert();
/* 109 */     if (model == null) {
/* 110 */       return null;
/*     */     }
/* 112 */     if ((model instanceof ReportJobAlertModel)) {
/* 113 */       return (ReportJobAlertModel)model;
/*     */     }
/* 115 */     throw new JSClientException("Please use ReportJobAlertModel instead of JobAlert in ReportJobModel class.");
/*     */   }
/*     */   
/*     */   public void setAlert(JobAlert alert)
/*     */   {
/* 120 */     super.setAlert(alert);
/*     */   }
/*     */   
/*     */   @XmlElement(name="mailNotificationModel")
/*     */   public ReportJobMailNotificationModel getMailNotification()
/*     */   {
/* 126 */     MailNotification model = super.getMailNotification();
/* 127 */     if (model == null) return null;
/* 128 */     if ((model instanceof ReportJobMailNotificationModel)) return (ReportJobMailNotificationModel)model;
/* 129 */     throw new JSClientException("Please use ReportJobMailNotificationModel instead of MailNotification in ReportJobModel class.");
/*     */   }
/*     */   
/*     */   public void setMailNotification(MailNotification mailNotification)
/*     */   {
/* 134 */     super.setMailNotification(mailNotification);
/*     */   }
/*     */   
/*     */   @XmlElement(name="repositoryDestinationModel")
/*     */   public ReportJobRepositoryDestinationModel getRepositoryDestination()
/*     */   {
/* 140 */     RepositoryDestination model = super.getRepositoryDestination();
/* 141 */     if (model == null) return null;
/* 142 */     if ((model instanceof ReportJobRepositoryDestinationModel)) return (ReportJobRepositoryDestinationModel)model;
/* 143 */     throw new JSClientException("Please use ReportJobRepositoryDestinationModel instead of RepositoryDestination in ReportJobModel class.");
/*     */   }
/*     */   
/*     */   public void setRepositoryDestination(RepositoryDestination contentRepositoryDestination)
/*     */   {
/* 148 */     super.setRepositoryDestination(contentRepositoryDestination);
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public Long getId()
/*     */   {
/* 157 */     return super.getId();
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setId(Long id) {
/* 164 */     super.setId(id);
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public Long getVersion()
/*     */   {
/* 173 */     return super.getVersion();
/*     */   }
/*     */   
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setVersion(Long version) {
/* 180 */     super.setVersion(version);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setDescription(String description)
/*     */   {
/* 190 */     super.setDescription(description);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setCreationDate(Timestamp creationDate)
/*     */   {
/* 201 */     super.setCreationDate(creationDate);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setLabel(String label)
/*     */   {
/* 211 */     super.setLabel(label);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setBaseOutputFilename(String baseOutputFilename)
/*     */   {
/* 222 */     super.setBaseOutputFilename(baseOutputFilename);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputFormatsSet(Set<OutputFormat> outputFormats)
/*     */   {
/* 233 */     super.setOutputFormats(outputFormats);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setUsername(String username)
/*     */   {
/* 249 */     super.setUsername(username);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputLocale(String outputLocale)
/*     */   {
/* 262 */     super.setOutputLocale(outputLocale);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\dto\jobs\reportjobmodel\ReportJobModel.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */