/*     */ package com.jaspersoft.jasperserver.ws.xml;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Argument;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ListItem;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.OperationResult;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Request;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceProperty;
/*     */ import java.io.StringReader;
/*     */ import java.util.Date;
/*     */ import java.util.List;
/*     */ import javax.xml.parsers.DocumentBuilder;
/*     */ import javax.xml.parsers.DocumentBuilderFactory;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.NamedNodeMap;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ import org.xml.sax.InputSource;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Unmarshaller
/*     */ {
/*  48 */   protected static final Log log = LogFactory.getLog(Unmarshaller.class);
/*     */   
/*  50 */   private String encoding = "UTF-8";
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String readPCDATA(Node textNode)
/*     */   {
/*  57 */     return readPCDATA(textNode, true);
/*     */   }
/*     */   
/*     */   public static String readPCDATA(Node textNode, boolean trim) {
/*  61 */     NodeList list_child = textNode.getChildNodes();
/*  62 */     for (int ck = 0; ck < list_child.getLength(); ck++) {
/*  63 */       Node child_child = list_child.item(ck);
/*     */       
/*     */ 
/*  66 */       Node ns = child_child.getNextSibling();
/*  67 */       if (ns != null) {
/*  68 */         child_child = ns;
/*     */       }
/*     */       
/*  71 */       short nt = child_child.getNodeType();
/*     */       
/*     */ 
/*  74 */       if (nt == 4) {
/*  75 */         if (trim) return child_child.getNodeValue().trim();
/*  76 */         return child_child.getNodeValue();
/*     */       }
/*     */     }
/*     */     
/*  80 */     for (int ck = 0; ck < list_child.getLength(); ck++) {
/*  81 */       Node child_child = list_child.item(ck);
/*     */       
/*     */ 
/*  84 */       Node ns = child_child.getNextSibling();
/*  85 */       if (ns != null) {
/*  86 */         child_child = ns;
/*     */       }
/*     */       
/*  89 */       short nt = child_child.getNodeType();
/*     */       
/*  91 */       if (nt == 3) {
/*  92 */         if (trim) return child_child.getNodeValue().trim();
/*  93 */         return child_child.getNodeValue();
/*     */       }
/*     */     }
/*     */     
/*  97 */     return "";
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Object unmarshal(Class c, StringReader sr)
/*     */     throws Exception
/*     */   {
/* 107 */     Unmarshaller u = new Unmarshaller();
/* 108 */     return u.unmarshal(sr);
/*     */   }
/*     */   
/*     */   public static Object unmarshalXml(String xmlString) throws Exception
/*     */   {
/* 113 */     Unmarshaller u = new Unmarshaller();
/* 114 */     return u.unmarshal(xmlString);
/*     */   }
/*     */   
/*     */   public static Object unmarshal(Class c, Element elm)
/*     */   {
/* 119 */     if (c.equals(ResourceDescriptor.class)) {
/* 120 */       return readResourceDescriptor(elm);
/*     */     }
/*     */     
/* 123 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object unmarshal(String xml)
/*     */     throws Exception
/*     */   {
/* 133 */     StringReader sreader = new StringReader(xml);
/* 134 */     return unmarshal(sreader);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Object unmarshal(StringReader sreader)
/*     */     throws Exception
/*     */   {
/*     */     try
/*     */     {
/* 146 */       DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
/* 147 */       DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
/*     */       
/* 149 */       InputSource input_source = new InputSource(sreader);
/* 150 */       Document document = docBuilder.parse(input_source);
/*     */       
/* 152 */       Node rootNode = document.getDocumentElement();
/*     */       
/* 154 */       if (rootNode.getNodeName().equals("request"))
/*     */       {
/* 156 */         return readRequest(rootNode);
/*     */       }
/* 158 */       if (rootNode.getNodeName().equals("operationResult"))
/*     */       {
/* 160 */         return readOperationResult(rootNode);
/*     */       }
/*     */     }
/*     */     catch (Exception e) {
/* 164 */       log.error(e);
/* 165 */       throw e;
/*     */     }
/*     */     
/* 168 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private Request readRequest(Node requestNode)
/*     */   {
/* 175 */     Request request = new Request();
/*     */     
/* 177 */     NamedNodeMap nodeAttributes = requestNode.getAttributes();
/*     */     
/* 179 */     if (nodeAttributes.getNamedItem("operationName") != null) {
/* 180 */       request.setOperationName(nodeAttributes.getNamedItem("operationName").getNodeValue());
/*     */     }
/* 182 */     if (nodeAttributes.getNamedItem("locale") != null) {
/* 183 */       request.setLocale(nodeAttributes.getNamedItem("locale").getNodeValue());
/*     */     }
/*     */     
/* 186 */     NodeList childsOfChild = requestNode.getChildNodes();
/* 187 */     for (int c_count = 0; c_count < childsOfChild.getLength(); c_count++) {
/* 188 */       Node child_child = childsOfChild.item(c_count);
/*     */       
/* 190 */       if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("argument"))) {
/* 191 */         request.getArguments().add(readArgument(child_child));
/*     */       }
/*     */       
/* 194 */       if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("resourceDescriptor"))) {
/* 195 */         request.setResourceDescriptor(readResourceDescriptor((Element)child_child));
/*     */       }
/*     */     }
/*     */     
/* 199 */     return request;
/*     */   }
/*     */   
/*     */   private Argument readArgument(Node argumentNode)
/*     */   {
/* 204 */     Argument argument = new Argument();
/* 205 */     NamedNodeMap nodeAttributes = argumentNode.getAttributes();
/*     */     
/* 207 */     if (nodeAttributes.getNamedItem("name") != null) {
/* 208 */       argument.setName(nodeAttributes.getNamedItem("name").getNodeValue());
/*     */     }
/* 210 */     argument.setValue(readPCDATA(argumentNode));
/*     */     
/* 212 */     return argument;
/*     */   }
/*     */   
/*     */   public static ResourceDescriptor readResourceDescriptor(Element rpNode)
/*     */   {
/* 217 */     ResourceDescriptor rd = new ResourceDescriptor();
/*     */     
/*     */     NamedNodeMap nodeAttributes;
/* 220 */     if ((rpNode instanceof Element)) {
/* 221 */       nodeAttributes = rpNode.getAttributes();
/*     */     }
/*     */     else
/*     */     {
/* 225 */       throw new IllegalStateException("repNode is not an Element");
/*     */     }
/*     */     NamedNodeMap nodeAttributes;
/* 228 */     if (nodeAttributes.getNamedItem("name") != null)
/* 229 */       rd.setName(nodeAttributes.getNamedItem("name").getNodeValue());
/* 230 */     if (nodeAttributes.getNamedItem("wsType") != null)
/* 231 */       rd.setWsType(nodeAttributes.getNamedItem("wsType").getNodeValue());
/* 232 */     if (nodeAttributes.getNamedItem("referenceType") != null)
/* 233 */       rd.setReferenceType(nodeAttributes.getNamedItem("referenceType").getNodeValue());
/* 234 */     if (nodeAttributes.getNamedItem("uriString") != null)
/* 235 */       rd.setUriString(nodeAttributes.getNamedItem("uriString").getNodeValue());
/* 236 */     if (nodeAttributes.getNamedItem("isNew") != null) {
/* 237 */       rd.setIsNew(nodeAttributes.getNamedItem("isNew").getNodeValue().equals("true"));
/*     */     }
/* 239 */     NodeList childsOfChild = rpNode.getChildNodes();
/* 240 */     for (int c_count = 0; c_count < childsOfChild.getLength(); c_count++) {
/* 241 */       Node child_child = childsOfChild.item(c_count);
/*     */       
/* 243 */       if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("label"))) {
/* 244 */         rd.setLabel(readPCDATA(child_child));
/*     */       }
/* 246 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("description"))) {
/* 247 */         rd.setDescription(readPCDATA(child_child));
/*     */       }
/* 249 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("creationDate"))) {
/* 250 */         Date creationDate = readCreationDate(child_child);
/* 251 */         if (creationDate != null) {
/* 252 */           rd.setCreationDate(creationDate);
/*     */         }
/*     */       }
/* 255 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("resourceProperty"))) {
/* 256 */         rd.setResourceProperty(readResourceProperty(child_child));
/*     */       }
/* 258 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("resourceDescriptor"))) {
/* 259 */         rd.getChildren().add(readResourceDescriptor((Element)child_child));
/*     */       }
/* 261 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("parameter"))) {
/* 262 */         rd.getParameters().add(readResourceParameter(child_child));
/*     */       }
/*     */     }
/*     */     
/* 266 */     return rd;
/*     */   }
/*     */   
/*     */   protected static Date readCreationDate(Node node) {
/* 270 */     Date creationDate = null;
/* 271 */     String dateStr = readPCDATA(node, true);
/* 272 */     if (dateStr.length() > 0) {
/*     */       try
/*     */       {
/* 275 */         long timestamp = Long.parseLong(dateStr);
/* 276 */         creationDate = new Date(timestamp);
/*     */       } catch (NumberFormatException e) {
/* 278 */         throw new RuntimeException("Error parsing resource creation date timestamp \"" + dateStr + "\"");
/*     */       }
/*     */     }
/*     */     
/* 282 */     return creationDate;
/*     */   }
/*     */   
/*     */ 
/*     */   private static ResourceProperty readResourceProperty(Node rpNode)
/*     */   {
/* 288 */     ResourceProperty rp = new ResourceProperty(null);
/* 289 */     NamedNodeMap nodeAttributes = rpNode.getAttributes();
/*     */     
/* 291 */     if (nodeAttributes.getNamedItem("name") != null) {
/* 292 */       rp.setName(nodeAttributes.getNamedItem("name").getNodeValue());
/*     */     }
/* 294 */     NodeList childsOfChild = rpNode.getChildNodes();
/* 295 */     for (int c_count = 0; c_count < childsOfChild.getLength(); c_count++) {
/* 296 */       Node child_child = childsOfChild.item(c_count);
/*     */       
/* 298 */       if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("value"))) {
/* 299 */         rp.setValue(readPCDATA(child_child));
/*     */       }
/* 301 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("resourceProperty"))) {
/* 302 */         rp.getProperties().add(readResourceProperty(child_child));
/*     */       }
/*     */     }
/* 305 */     return rp;
/*     */   }
/*     */   
/*     */   private static ListItem readResourceParameter(Node rpNode)
/*     */   {
/* 310 */     ListItem rp = new ListItem();
/* 311 */     NamedNodeMap nodeAttributes = rpNode.getAttributes();
/*     */     
/* 313 */     if (nodeAttributes.getNamedItem("name") != null) {
/* 314 */       rp.setLabel(nodeAttributes.getNamedItem("name").getNodeValue());
/*     */     }
/* 316 */     if (nodeAttributes.getNamedItem("isListItem") != null) {
/* 317 */       rp.setIsListItem(nodeAttributes.getNamedItem("isListItem").getNodeValue().equals("true"));
/*     */     }
/* 319 */     rp.setValue(readPCDATA(rpNode));
/*     */     
/* 321 */     return rp;
/*     */   }
/*     */   
/*     */ 
/*     */   private OperationResult readOperationResult(Node operationResultNode)
/*     */   {
/* 327 */     OperationResult or = new OperationResult();
/*     */     
/* 329 */     NamedNodeMap nodeAttributes = operationResultNode.getAttributes();
/*     */     
/* 331 */     if (nodeAttributes.getNamedItem("version") != null) {
/* 332 */       or.setVersion(nodeAttributes.getNamedItem("version").getNodeValue());
/*     */     }
/* 334 */     NodeList childsOfChild = operationResultNode.getChildNodes();
/* 335 */     for (int c_count = 0; c_count < childsOfChild.getLength(); c_count++) {
/* 336 */       Node child_child = childsOfChild.item(c_count);
/*     */       
/* 338 */       if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("returnCode"))) {
/* 339 */         or.setReturnCode(Integer.parseInt(readPCDATA(child_child)));
/*     */       }
/* 341 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("returnMessage"))) {
/* 342 */         or.setMessage(readPCDATA(child_child));
/*     */       }
/* 344 */       else if ((child_child.getNodeType() == 1) && (child_child.getNodeName().equals("resourceDescriptor"))) {
/* 345 */         or.getResourceDescriptors().add(readResourceDescriptor((Element)child_child));
/*     */       }
/*     */     }
/*     */     
/* 349 */     return or;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-common-ws-6.0.jar!\com\jaspersoft\jasperserver\ws\xml\Unmarshaller.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */