/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import java.text.SimpleDateFormat;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.TimeZone;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.Schema.Field;
/*     */ import org.apache.avro.generic.GenericData.Array;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Identifier
/*     */   extends AvroTransmissionObject
/*     */ {
/*     */   private static final String IDENTIFIER_PROCESSED = "identifierProcessed";
/*     */   private static final String IS_SECURE_USER = "isSecureUser";
/*     */   private static final String SYS_VERSION = "sysVersion";
/*     */   private static final String ASUP_TYPE = "asup_type";
/*     */   private static final String HASH = "hash";
/*     */   private static final String SYS_SERIAL_NUMBER = "sysSerialNumber";
/*     */   private static final String SYS_ID = "sysId";
/*     */   private static final String ID = "id";
/*     */   private static final String IS_CLUSTER_ROOT = "isClusterRoot";
/*     */   private static final String TIME_STAMP = "timeStamp";
/*     */   private static final String PATH = "path";
/*     */   private static final String BIZ_KEY = "biz_key";
/*     */   private static final String OPTION_GROUP_ID = "option_group_id";
/*     */   private static final String RAW_FILTER = "rawFilter";
/*     */   private static final String GMT = "GMT";
/*     */   private static final char UNDERSCORE_CHAR = '_';
/*     */   private static final String GENDATE_FORAMT = "yyyy-MM-dd hh:mm:ss";
/*     */   
/*     */   private Identifier(ARMASchema schema)
/*     */   {
/*  54 */     super(schema, null, null);
/*     */   }
/*     */   
/*     */   public Identifier(String id) {
/*  58 */     super(ARMASchema.IDENTIFIER, null, id);
/*  59 */     setId(id);
/*  60 */     StringBuilder reqId = new StringBuilder(id);
/*  61 */     setHash(String.valueOf(getGeneratedHashBasedOnTS(reqId).hashCode()));
/*  62 */     setSecureUser(String.valueOf(Boolean.FALSE));
/*  63 */     setIdentifierProcessed(String.valueOf(Boolean.FALSE));
/*     */   }
/*     */   
/*     */   public Identifier(GenericRecord object, String id) {
/*  67 */     super(ARMASchema.IDENTIFIER, object, null, id);
/*     */   }
/*     */   
/*     */   public GenericRecord getObject()
/*     */   {
/*  72 */     return (GenericRecord)this.object;
/*     */   }
/*     */   
/*     */   void setClusterId(String clusterId) {
/*  76 */     putStringValue("clusterId", clusterId);
/*     */   }
/*     */   
/*     */   public String getClusterId() {
/*  80 */     return getStringValue("clusterId");
/*     */   }
/*     */   
/*     */   void setId(String id) {
/*  84 */     putStringValue("id", id);
/*     */   }
/*     */   
/*     */   public void setTimeStamp(String timeStamp) {
/*  88 */     putStringValue("timeStamp", timeStamp);
/*     */   }
/*     */   
/*     */   public String getTimeStamp() {
/*  92 */     return getStringValue("timeStamp");
/*     */   }
/*     */   
/*     */   public void setSecureUser(String isSecureUser) {
/*  96 */     putStringValue("isSecureUser", isSecureUser);
/*     */   }
/*     */   
/*     */   public String getSecureUser() {
/* 100 */     return getStringValue("isSecureUser");
/*     */   }
/*     */   
/*     */   public void setClusterRoot(String isClusterRoot) {
/* 104 */     putStringValue("isClusterRoot", isClusterRoot);
/*     */   }
/*     */   
/*     */   public String getClusterRoot() {
/* 108 */     return getStringValue("isClusterRoot");
/*     */   }
/*     */   
/*     */   public void setSysId(String sysId) {
/* 112 */     putStringValue("sysId", sysId);
/*     */   }
/*     */   
/*     */   public String getSysId() {
/* 116 */     return getStringValue("sysId");
/*     */   }
/*     */   
/*     */   void setSysSerialNumber(String sysSerialNumber) {
/* 120 */     putStringValue("sysSerialNumber", sysSerialNumber);
/*     */   }
/*     */   
/*     */   public String getSysSerialNumber() {
/* 124 */     return getStringValue("sysSerialNumber");
/*     */   }
/*     */   
/*     */   void setHash(String hash) {
/* 128 */     putStringValue("hash", hash);
/*     */   }
/*     */   
/*     */   public String getHash() {
/* 132 */     return getStringValue("hash");
/*     */   }
/*     */   
/*     */   public void setSysVersion(Utf8 sysVersion) {
/* 136 */     putUtf8Value("sysVersion", sysVersion);
/*     */   }
/*     */   
/*     */   private void putUtf8Value(String name, Utf8 value) {
/* 140 */     ((GenericRecord)this.object).put(name, value);
/*     */   }
/*     */   
/*     */   public String getSysVersion()
/*     */   {
/* 145 */     return getStringValue("sysVersion");
/*     */   }
/*     */   
/*     */   public void setAsupType(Utf8 asup_type) {
/* 149 */     putUtf8Value("asup_type", asup_type);
/*     */   }
/*     */   
/*     */   public String getAsupType() {
/* 153 */     return getStringValue("asup_type");
/*     */   }
/*     */   
/*     */   public void setBizKeys(GenericData.Array<Utf8> bizKeys) {
/* 157 */     ((GenericRecord)this.object).put("biz_key", bizKeys);
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getBizKeys()
/*     */   {
/* 162 */     return (GenericData.Array)((GenericRecord)this.object).get("biz_key");
/*     */   }
/*     */   
/*     */ 
/*     */   public void setOptionGroupIds(GenericData.Array<Utf8> optionGroupIds)
/*     */   {
/* 168 */     ((GenericRecord)this.object).put("option_group_id", optionGroupIds);
/*     */   }
/*     */   
/*     */ 
/*     */   public GenericData.Array<Utf8> getOptionGroupIds()
/*     */   {
/* 174 */     return (GenericData.Array)((GenericRecord)this.object).get("option_group_id");
/*     */   }
/*     */   
/*     */ 
/*     */   public void setPath(GenericData.Array<Utf8> path)
/*     */   {
/* 180 */     ((GenericRecord)this.object).put("path", path);
/*     */   }
/*     */   
/*     */   public GenericData.Array<Utf8> getPath()
/*     */   {
/* 185 */     return (GenericData.Array)((GenericRecord)this.object).get("path");
/*     */   }
/*     */   
/*     */   public void setFilter(Map<String, Map<String, String>> filters)
/*     */   {
/* 190 */     Map<Utf8, Map<Utf8, Utf8>> filterData = new HashMap();
/*     */     
/*     */ 
/*     */ 
/* 194 */     for (String key : filters.keySet()) {
/* 195 */       Map<String, String> attrMap = (Map)filters.get(key);
/* 196 */       Map<Utf8, Utf8> filterAttrData = new HashMap();
/* 197 */       for (String attrKey : attrMap.keySet()) {
/* 198 */         filterAttrData.put(new Utf8(attrKey), new Utf8((String)attrMap.get(attrKey)));
/*     */       }
/* 200 */       filterData.put(new Utf8(key), filterAttrData);
/*     */     }
/*     */     
/* 203 */     ((GenericRecord)this.object).put("rawFilter", filterData);
/*     */   }
/*     */   
/*     */   public Map<Utf8, Map<Utf8, Utf8>> getFilter()
/*     */   {
/* 208 */     Map<Utf8, Map<Utf8, Utf8>> filters = (Map)((GenericRecord)this.object).get("rawFilter");
/*     */     
/* 210 */     if (null == filters)
/* 211 */       filters = new HashMap();
/* 212 */     return filters;
/*     */   }
/*     */   
/*     */   public Schema getBizKeySchema() {
/* 216 */     return ((GenericRecord)this.object).getSchema().getField("biz_key").schema();
/*     */   }
/*     */   
/*     */   public Schema getOptionGroupIdSchema() {
/* 220 */     return ((GenericRecord)this.object).getSchema().getField("option_group_id").schema();
/*     */   }
/*     */   
/*     */   public Schema getPathKeySchema() {
/* 224 */     return ((GenericRecord)this.object).getSchema().getField("path").schema();
/*     */   }
/*     */   
/*     */   public static Identifier initialize(String clusterId, String timeStamp, boolean secureUser)
/*     */   {
/* 229 */     Identifier identifier = new Identifier(ARMASchema.IDENTIFIER);
/* 230 */     identifier.setClusterId(clusterId);
/* 231 */     identifier.setSecureUser(String.valueOf(secureUser));
/* 232 */     setDefaultValues(timeStamp, identifier);
/* 233 */     return identifier;
/*     */   }
/*     */   
/*     */   public static Identifier initialize(String clusterId, String sysId, String timeStamp, boolean secureUser, boolean clusteredSystem) {
/* 237 */     Identifier identifier = new Identifier(ARMASchema.IDENTIFIER);
/* 238 */     identifier.setClusterId(clusterId);
/* 239 */     identifier.setSysId(sysId);
/* 240 */     identifier.setSecureUser(String.valueOf(secureUser));
/* 241 */     setDefaultValues(timeStamp, identifier);
/* 242 */     return identifier;
/*     */   }
/*     */   
/*     */   public static Identifier initialize(String sysId, String sysSerialNumber, String timeStamp, boolean secureUser) {
/* 246 */     Identifier identifier = new Identifier(ARMASchema.IDENTIFIER);
/* 247 */     identifier.setSysId(sysId);
/* 248 */     identifier.setSysSerialNumber(sysSerialNumber);
/* 249 */     identifier.setSecureUser(String.valueOf(secureUser));
/* 250 */     setDefaultValues(timeStamp, identifier);
/* 251 */     return identifier;
/*     */   }
/*     */   
/*     */   public static Identifier initialize(String bizKey, boolean secureUser)
/*     */   {
/* 256 */     Identifier identifier = new Identifier(ARMASchema.IDENTIFIER);
/* 257 */     GenericData.Array<Utf8> defaultBizKey = new GenericData.Array(1, identifier.getBizKeySchema());
/* 258 */     defaultBizKey.add(new Utf8(bizKey));
/* 259 */     identifier.setBizKeys(defaultBizKey);
/* 260 */     GenericData.Array<Utf8> defaultOptionGroupId = new GenericData.Array(0, identifier.getOptionGroupIdSchema());
/* 261 */     identifier.setOptionGroupIds(defaultOptionGroupId);
/* 262 */     identifier.setSecureUser(String.valueOf(secureUser));
/* 263 */     setDefPathAndFilters(identifier);
/* 264 */     setIdentifierDefaults(identifier);
/* 265 */     return identifier;
/*     */   }
/*     */   
/*     */   private static void setTimeStamp(String timeStamp, Identifier identifier) {
/* 269 */     if (null != timeStamp) {
/* 270 */       identifier.setTimeStamp(timeStamp);
/*     */     }
/*     */   }
/*     */   
/*     */   private static void setDefaultValues(String timeStamp, Identifier identifier) {
/* 275 */     GenericData.Array<Utf8> defaultBizKey = new GenericData.Array(0, identifier.getBizKeySchema());
/*     */     
/* 277 */     GenericData.Array<Utf8> defaultOptionGroupId = new GenericData.Array(0, identifier.getOptionGroupIdSchema());
/* 278 */     identifier.setOptionGroupIds(defaultOptionGroupId);
/* 279 */     setDefPathAndFilters(identifier);
/* 280 */     identifier.setBizKeys(defaultBizKey);
/* 281 */     setTimeStamp(timeStamp, identifier);
/* 282 */     setIdentifierDefaults(identifier);
/*     */   }
/*     */   
/*     */   private static void setIdentifierDefaults(Identifier identifier) {
/* 286 */     identifier.setIdentifierProcessed(String.valueOf(Boolean.FALSE));
/* 287 */     identifier.populateFields();
/*     */   }
/*     */   
/*     */   private static void setDefPathAndFilters(Identifier identifier) {
/* 291 */     GenericData.Array<Utf8> defaultPath = new GenericData.Array(0, identifier.getPathKeySchema());
/*     */     
/* 293 */     identifier.setPath(defaultPath);
/* 294 */     Map<String, Map<String, String>> rawFilters = new HashMap();
/* 295 */     identifier.setFilter(rawFilters);
/*     */   }
/*     */   
/*     */ 
/*     */   private String getViewTimeStamp()
/*     */   {
/* 301 */     String timeStamp = getTimeStamp();
/* 302 */     if (null == timeStamp) {
/* 303 */       SimpleDateFormat bizKeyFormat = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
/* 304 */       bizKeyFormat.setTimeZone(TimeZone.getTimeZone("GMT"));
/* 305 */       timeStamp = bizKeyFormat.format(Long.valueOf(System.currentTimeMillis()));
/*     */     }
/*     */     
/* 308 */     return timeStamp;
/*     */   }
/*     */   
/*     */   public boolean isCurrent() {
/* 312 */     return getTimeStamp() == null;
/*     */   }
/*     */   
/*     */   public boolean isCluster() {
/* 316 */     return getClusterId() != null;
/*     */   }
/*     */   
/*     */   public void setIdentifierProcessed(String identifierProcessed) {
/* 320 */     putStringValue("identifierProcessed", identifierProcessed);
/*     */   }
/*     */   
/*     */   public String isIdentifierProcessed() {
/* 324 */     return getStringValue("identifierProcessed");
/*     */   }
/*     */   
/*     */   private void populateFields()
/*     */   {
/* 329 */     StringBuilder reqId = new StringBuilder();
/* 330 */     StringBuilder hashGen = null;
/* 331 */     String clusterId = getClusterId();
/* 332 */     String sysId = getSysId();
/* 333 */     if (null != clusterId) {
/* 334 */       reqId.append(clusterId);
/* 335 */       if (null != sysId) {
/* 336 */         reqId.append('_');
/* 337 */         reqId.append(sysId);
/*     */       }
/* 339 */       hashGen = getGeneratedHashBasedOnTS(reqId);
/*     */     }
/* 341 */     else if (getBizKeys().size() != 0) {
/* 342 */       reqId.append(getBizKeys());
/* 343 */       hashGen = new StringBuilder(reqId);
/*     */     }
/*     */     else {
/* 346 */       reqId.append(sysId);
/* 347 */       reqId.append('_');
/* 348 */       reqId.append(getSysSerialNumber());
/* 349 */       hashGen = getGeneratedHashBasedOnTS(reqId);
/*     */     }
/*     */     
/* 352 */     reqId.append('_');
/* 353 */     reqId.append(getSecureUser());
/*     */     
/* 355 */     setId(reqId.toString());
/*     */     
/* 357 */     setHash(hashGen.toString().replaceAll(" ", "").trim());
/*     */   }
/*     */   
/*     */   private StringBuilder getGeneratedHashBasedOnTS(StringBuilder reqId) {
/* 361 */     StringBuilder hashGen = new StringBuilder(reqId);
/* 362 */     reqId.append('_');
/* 363 */     String timeStamp = getTimeStamp();
/* 364 */     reqId.append(timeStamp);
/*     */     
/* 366 */     hashGen.append('_');
/*     */     
/* 368 */     hashGen.append(getViewTimeStamp());
/* 369 */     return hashGen;
/*     */   }
/*     */   
/*     */   public boolean isInitialized() {
/* 373 */     String sysVersion = getSysVersion();
/* 374 */     String asupType = getAsupType();
/* 375 */     return (isNotEmpty(sysVersion)) && (isNotEmpty(asupType));
/*     */   }
/*     */   
/*     */   private boolean isNotEmpty(String str) {
/* 379 */     return (null != str) && (str.length() != 0);
/*     */   }
/*     */   
/*     */   public String getId()
/*     */   {
/* 384 */     return getStringValue("id");
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\Identifier.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */