/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class InterningXmlVisitor
/*     */   implements XmlVisitor
/*     */ {
/*     */   private final XmlVisitor next;
/*  16 */   private final AttributesImpl attributes = new AttributesImpl(null);
/*     */   
/*     */   public InterningXmlVisitor(XmlVisitor next) {
/*  19 */     this.next = next;
/*     */   }
/*     */   
/*     */   public void startDocument(LocatorEx locator, NamespaceContext nsContext) throws SAXException {
/*  23 */     this.next.startDocument(locator, nsContext);
/*     */   }
/*     */   
/*     */   public void endDocument() throws SAXException {
/*  27 */     this.next.endDocument();
/*     */   }
/*     */   
/*     */   public void startElement(TagName tagName) throws SAXException {
/*  31 */     this.attributes.setAttributes(tagName.atts);
/*  32 */     tagName.atts = this.attributes;
/*  33 */     tagName.uri = intern(tagName.uri);
/*  34 */     tagName.local = intern(tagName.local);
/*  35 */     this.next.startElement(tagName);
/*     */   }
/*     */   
/*     */   public void endElement(TagName tagName) throws SAXException {
/*  39 */     tagName.uri = intern(tagName.uri);
/*  40 */     tagName.local = intern(tagName.local);
/*  41 */     this.next.endElement(tagName);
/*     */   }
/*     */   
/*     */   public void startPrefixMapping(String prefix, String nsUri) throws SAXException {
/*  45 */     this.next.startPrefixMapping(intern(prefix), intern(nsUri));
/*     */   }
/*     */   
/*     */   public void endPrefixMapping(String prefix) throws SAXException {
/*  49 */     this.next.endPrefixMapping(intern(prefix));
/*     */   }
/*     */   
/*     */   public void text(CharSequence pcdata) throws SAXException {
/*  53 */     this.next.text(pcdata);
/*     */   }
/*     */   
/*     */   public UnmarshallingContext getContext() {
/*  57 */     return this.next.getContext();
/*     */   }
/*     */   
/*     */   public XmlVisitor.TextPredictor getPredictor() {
/*  61 */     return this.next.getPredictor();
/*     */   }
/*     */   
/*     */   private static class AttributesImpl implements Attributes {
/*     */     private Attributes core;
/*     */     
/*     */     void setAttributes(Attributes att) {
/*  68 */       this.core = att;
/*     */     }
/*     */     
/*     */     public int getIndex(String qName) {
/*  72 */       return this.core.getIndex(qName);
/*     */     }
/*     */     
/*     */     public int getIndex(String uri, String localName) {
/*  76 */       return this.core.getIndex(uri, localName);
/*     */     }
/*     */     
/*     */     public int getLength() {
/*  80 */       return this.core.getLength();
/*     */     }
/*     */     
/*     */     public String getLocalName(int index) {
/*  84 */       return InterningXmlVisitor.intern(this.core.getLocalName(index));
/*     */     }
/*     */     
/*     */     public String getQName(int index) {
/*  88 */       return InterningXmlVisitor.intern(this.core.getQName(index));
/*     */     }
/*     */     
/*     */     public String getType(int index) {
/*  92 */       return InterningXmlVisitor.intern(this.core.getType(index));
/*     */     }
/*     */     
/*     */     public String getType(String qName) {
/*  96 */       return InterningXmlVisitor.intern(this.core.getType(qName));
/*     */     }
/*     */     
/*     */     public String getType(String uri, String localName) {
/* 100 */       return InterningXmlVisitor.intern(this.core.getType(uri, localName));
/*     */     }
/*     */     
/*     */     public String getURI(int index) {
/* 104 */       return InterningXmlVisitor.intern(this.core.getURI(index));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public String getValue(int index)
/*     */     {
/* 113 */       return this.core.getValue(index);
/*     */     }
/*     */     
/*     */     public String getValue(String qName) {
/* 117 */       return this.core.getValue(qName);
/*     */     }
/*     */     
/*     */     public String getValue(String uri, String localName) {
/* 121 */       return this.core.getValue(uri, localName);
/*     */     }
/*     */   }
/*     */   
/*     */   private static String intern(String s) {
/* 126 */     if (s == null) return null;
/* 127 */     return s.intern();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\InterningXmlVisitor.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */