/*     */ package net.rubyeye.xmemcached.command;
/*     */ 
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.Collection;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.CommandFactory;
/*     */ import net.rubyeye.xmemcached.buffer.BufferAllocator;
/*     */ import net.rubyeye.xmemcached.command.kestrel.KestrelDeleteCommand;
/*     */ import net.rubyeye.xmemcached.command.kestrel.KestrelFlushAllCommand;
/*     */ import net.rubyeye.xmemcached.command.kestrel.KestrelGetCommand;
/*     */ import net.rubyeye.xmemcached.command.kestrel.KestrelSetCommand;
/*     */ import net.rubyeye.xmemcached.command.text.TextQuitCommand;
/*     */ import net.rubyeye.xmemcached.command.text.TextStatsCommand;
/*     */ import net.rubyeye.xmemcached.transcoders.Transcoder;
/*     */ import net.rubyeye.xmemcached.utils.Protocol;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class KestrelCommandFactory
/*     */   implements CommandFactory
/*     */ {
/*     */   public Command createAddCommand(String key, byte[] keyBytes, int exp, Object value, boolean noreply, Transcoder transcoder)
/*     */   {
/*  33 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createAppendCommand(String key, byte[] keyBytes, Object value, boolean noreply, Transcoder transcoder)
/*     */   {
/*  39 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createCASCommand(String key, byte[] keyBytes, int exp, Object value, long cas, boolean noreply, Transcoder transcoder)
/*     */   {
/*  45 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createDeleteCommand(String key, byte[] keyBytes, int time, boolean noreply)
/*     */   {
/*  51 */     return new KestrelDeleteCommand(key, keyBytes, -1, new CountDownLatch(1), noreply);
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createFlushAllCommand(CountDownLatch latch, int delay, boolean noreply)
/*     */   {
/*  57 */     return new KestrelFlushAllCommand(latch, delay, noreply);
/*     */   }
/*     */   
/*     */   public Command createGetCommand(String key, byte[] keyBytes, CommandType cmdType, Transcoder transcoder)
/*     */   {
/*  62 */     return new KestrelGetCommand(key, keyBytes, cmdType, new CountDownLatch(1), transcoder);
/*     */   }
/*     */   
/*     */ 
/*     */   public <T> Command createGetMultiCommand(Collection<String> keys, CountDownLatch latch, CommandType cmdType, Transcoder<T> transcoder)
/*     */   {
/*  68 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Command createIncrDecrCommand(String key, byte[] keyBytes, long amount, long initial, int expTime, CommandType cmdType, boolean noreply)
/*     */   {
/*  75 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createPrependCommand(String key, byte[] keyBytes, Object value, boolean noreply, Transcoder transcoder)
/*     */   {
/*  81 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createReplaceCommand(String key, byte[] keyBytes, int exp, Object value, boolean noreply, Transcoder transcoder)
/*     */   {
/*  87 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createSetCommand(String key, byte[] keyBytes, int exp, Object value, boolean noreply, Transcoder transcoder)
/*     */   {
/*  93 */     return new KestrelSetCommand(key, keyBytes, CommandType.SET, new CountDownLatch(1), exp, -1L, value, noreply, transcoder);
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createStatsCommand(InetSocketAddress server, CountDownLatch latch, String itemName)
/*     */   {
/*  99 */     if (itemName != null) {
/* 100 */       throw new UnsupportedOperationException("Kestrel doesn't support 'stats itemName'");
/*     */     }
/*     */     
/* 103 */     return new TextStatsCommand(server, latch, null);
/*     */   }
/*     */   
/*     */   public Command createVerbosityCommand(CountDownLatch latch, int level, boolean noreply)
/*     */   {
/* 108 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createVersionCommand(CountDownLatch latch, InetSocketAddress server)
/*     */   {
/* 114 */     throw new UnsupportedOperationException("Kestrel doesn't support this operation");
/*     */   }
/*     */   
/*     */   public Command createQuitCommand()
/*     */   {
/* 119 */     return new TextQuitCommand();
/*     */   }
/*     */   
/*     */   public Protocol getProtocol() {
/* 123 */     return Protocol.Kestrel;
/*     */   }
/*     */   
/*     */   public Command createAuthListMechanismsCommand(CountDownLatch latch) {
/* 127 */     throw new UnsupportedOperationException("Kestrel doesn't support SASL");
/*     */   }
/*     */   
/*     */   public Command createAuthStartCommand(String mechanism, CountDownLatch latch, byte[] authData)
/*     */   {
/* 132 */     throw new UnsupportedOperationException("Kestrel doesn't support SASL");
/*     */   }
/*     */   
/*     */   public Command createAuthStepCommand(String mechanism, CountDownLatch latch, byte[] authData)
/*     */   {
/* 137 */     throw new UnsupportedOperationException("Kestrel doesn't support SASL");
/*     */   }
/*     */   
/*     */   public Command createGetAndTouchCommand(String key, byte[] keyBytes, CountDownLatch latch, int exp, boolean noreply)
/*     */   {
/* 142 */     throw new UnsupportedOperationException("GAT is only supported by binary protocol");
/*     */   }
/*     */   
/*     */ 
/*     */   public Command createTouchCommand(String key, byte[] keyBytes, CountDownLatch latch, int exp, boolean noreply)
/*     */   {
/* 148 */     throw new UnsupportedOperationException("Touch is only supported by binary protocol");
/*     */   }
/*     */   
/*     */   public void setBufferAllocator(BufferAllocator bufferAllocator) {}
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\command\KestrelCommandFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */