/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.buffer.IoBuffer;
/*     */ import com.google.code.yanf4j.core.impl.FutureImpl;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Queue;
/*     */ import java.util.concurrent.CountDownLatch;
/*     */ import net.rubyeye.xmemcached.MemcachedOptimizer;
/*     */ import net.rubyeye.xmemcached.buffer.BufferAllocator;
/*     */ import net.rubyeye.xmemcached.command.AssocCommandAware;
/*     */ import net.rubyeye.xmemcached.command.Command;
/*     */ import net.rubyeye.xmemcached.command.CommandType;
/*     */ import net.rubyeye.xmemcached.command.OperationStatus;
/*     */ import net.rubyeye.xmemcached.command.binary.BaseBinaryCommand;
/*     */ import net.rubyeye.xmemcached.command.binary.BinaryGetCommand;
/*     */ import net.rubyeye.xmemcached.command.binary.BinaryGetMultiCommand;
/*     */ import net.rubyeye.xmemcached.command.binary.OpCode;
/*     */ import net.rubyeye.xmemcached.command.text.TextGetOneCommand;
/*     */ import net.rubyeye.xmemcached.monitor.Constants;
/*     */ import net.rubyeye.xmemcached.monitor.MemcachedClientNameHolder;
/*     */ import net.rubyeye.xmemcached.monitor.XMemcachedMbeanServer;
/*     */ import net.rubyeye.xmemcached.utils.ByteUtils;
/*     */ import net.rubyeye.xmemcached.utils.Protocol;
/*     */ import org.slf4j.Logger;
/*     */ import org.slf4j.LoggerFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Optimizer
/*     */   implements OptimizerMBean, MemcachedOptimizer
/*     */ {
/*     */   public static final int DEFAULT_MERGE_FACTOR = 50;
/*  66 */   private int mergeFactor = 50;
/*  67 */   private boolean optimiezeGet = true;
/*  68 */   private boolean optimiezeMergeBuffer = true;
/*  69 */   private static final Logger log = LoggerFactory.getLogger(Optimizer.class);
/*  70 */   private Protocol protocol = Protocol.Binary;
/*     */   
/*     */   public Optimizer(Protocol protocol) {
/*  73 */     XMemcachedMbeanServer.getInstance().registMBean(this, getClass().getPackage().getName() + ":type=" + getClass().getSimpleName() + "-" + MemcachedClientNameHolder.getName());
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*  78 */     this.protocol = protocol;
/*     */   }
/*     */   
/*     */ 
/*     */   public void setBufferAllocator(BufferAllocator bufferAllocator) {}
/*     */   
/*     */   public int getMergeFactor()
/*     */   {
/*  86 */     return this.mergeFactor;
/*     */   }
/*     */   
/*     */   public void setMergeFactor(int mergeFactor) {
/*  90 */     log.warn("change mergeFactor from " + this.mergeFactor + " to " + mergeFactor);
/*     */     
/*  92 */     this.mergeFactor = mergeFactor;
/*     */   }
/*     */   
/*     */   public boolean isOptimizeGet()
/*     */   {
/*  97 */     return this.optimiezeGet;
/*     */   }
/*     */   
/*     */   public void setOptimizeGet(boolean optimiezeGet) {
/* 101 */     log.warn(optimiezeGet ? "Enable merge get commands" : "Disable merge get commands");
/*     */     
/* 103 */     this.optimiezeGet = optimiezeGet;
/*     */   }
/*     */   
/*     */   public boolean isOptimizeMergeBuffer() {
/* 107 */     return this.optimiezeMergeBuffer;
/*     */   }
/*     */   
/*     */   public void setOptimizeMergeBuffer(boolean optimiezeMergeBuffer) {
/* 111 */     log.warn(optimiezeMergeBuffer ? "Enable merge buffers" : "Disable merge buffers");
/*     */     
/* 113 */     this.optimiezeMergeBuffer = optimiezeMergeBuffer;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Command optimize(Command currentCommand, Queue writeQueue, Queue<Command> executingCmds, int sendBufferSize)
/*     */   {
/* 120 */     Command optimiezeCommand = currentCommand;
/* 121 */     optimiezeCommand = optimiezeGet(writeQueue, executingCmds, optimiezeCommand);
/*     */     
/* 123 */     optimiezeCommand = optimiezeMergeBuffer(optimiezeCommand, writeQueue, executingCmds, sendBufferSize);
/*     */     
/* 125 */     return optimiezeCommand;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Command optimiezeMergeBuffer(Command optimiezeCommand, Queue writeQueue, Queue<Command> executingCmds, int sendBufferSize)
/*     */   {
/* 139 */     if (log.isDebugEnabled()) {
/* 140 */       log.debug("Optimieze merge buffer:" + optimiezeCommand.toString());
/*     */     }
/* 142 */     if ((this.optimiezeMergeBuffer) && (optimiezeCommand.getIoBuffer().remaining() < sendBufferSize))
/*     */     {
/* 144 */       optimiezeCommand = mergeBuffer(optimiezeCommand, writeQueue, executingCmds, sendBufferSize);
/*     */     }
/*     */     
/* 147 */     return optimiezeCommand;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Command optimiezeGet(Queue writeQueue, Queue<Command> executingCmds, Command optimiezeCommand)
/*     */   {
/* 161 */     if ((optimiezeCommand.getCommandType() == CommandType.GET_ONE) || (optimiezeCommand.getCommandType() == CommandType.GETS_ONE))
/*     */     {
/*     */ 
/* 164 */       if (this.optimiezeGet) {
/* 165 */         optimiezeCommand = mergeGetCommands(optimiezeCommand, writeQueue, executingCmds, optimiezeCommand.getCommandType());
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 170 */     return optimiezeCommand;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   private final Command mergeBuffer(Command firstCommand, Queue writeQueue, Queue<Command> executingCmds, int sendBufferSize)
/*     */   {
/* 177 */     Command lastCommand = firstCommand;
/* 178 */     Command nextCmd = (Command)writeQueue.peek();
/* 179 */     if (nextCmd == null) {
/* 180 */       return lastCommand;
/*     */     }
/*     */     
/* 183 */     List<Command> commands = getLocalList();
/* 184 */     ByteBuffer firstBuffer = firstCommand.getIoBuffer().buf();
/* 185 */     int totalBytes = firstBuffer.remaining();
/* 186 */     commands.add(firstCommand);
/* 187 */     boolean wasFirst = true;
/*     */     
/* 189 */     while ((totalBytes + nextCmd.getIoBuffer().remaining() <= sendBufferSize) && ((nextCmd = (Command)writeQueue.peek()) != null) && 
/* 190 */       (nextCmd.getStatus() != OperationStatus.WRITING))
/*     */     {
/*     */ 
/* 193 */       if (nextCmd.isCancel()) {
/* 194 */         writeQueue.remove();
/*     */       }
/*     */       else {
/* 197 */         nextCmd.setStatus(OperationStatus.WRITING);
/*     */         
/* 199 */         writeQueue.remove();
/*     */         
/* 201 */         if (wasFirst) {
/* 202 */           wasFirst = false;
/*     */         }
/*     */         
/* 205 */         if (((nextCmd.getCommandType() == CommandType.GET_ONE) || (nextCmd.getCommandType() == CommandType.GETS_ONE)) && (this.optimiezeGet))
/*     */         {
/*     */ 
/* 208 */           nextCmd = mergeGetCommands(nextCmd, writeQueue, executingCmds, nextCmd.getCommandType());
/*     */         }
/*     */         
/*     */ 
/* 212 */         commands.add(nextCmd);
/* 213 */         lastCommand = nextCmd;
/* 214 */         totalBytes += nextCmd.getIoBuffer().remaining();
/* 215 */         if (totalBytes > sendBufferSize) {
/*     */           break;
/*     */         }
/*     */       }
/*     */     }
/* 220 */     if (commands.size() > 1) {
/* 221 */       byte[] buf = new byte[totalBytes];
/* 222 */       int offset = 0;
/* 223 */       for (Command command : commands) {
/* 224 */         byte[] ba = command.getIoBuffer().array();
/* 225 */         System.arraycopy(ba, 0, buf, offset, ba.length);
/* 226 */         offset += ba.length;
/* 227 */         if ((command != lastCommand) && ((!command.isNoreply()) || ((command instanceof BaseBinaryCommand))))
/*     */         {
/* 229 */           executingCmds.add(command);
/*     */         }
/*     */       }
/* 232 */       lastCommand.setIoBuffer(IoBuffer.wrap(buf));
/*     */     }
/* 234 */     return lastCommand;
/*     */   }
/*     */   
/* 237 */   private final ThreadLocal<List<Command>> threadLocal = new ThreadLocal()
/*     */   {
/*     */     protected List<Command> initialValue()
/*     */     {
/* 241 */       return new ArrayList(Optimizer.this.mergeFactor);
/*     */     }
/*     */   };
/*     */   
/*     */   public final List<Command> getLocalList() {
/* 246 */     List<Command> list = (List)this.threadLocal.get();
/* 247 */     list.clear();
/* 248 */     return list;
/*     */   }
/*     */   
/*     */   static abstract interface CommandCollector {
/*     */     public abstract Object getResult();
/*     */     
/*     */     public abstract void visit(Command paramCommand);
/*     */     
/*     */     public abstract void finish();
/*     */   }
/*     */   
/*     */   static class KeyStringCollector implements Optimizer.CommandCollector {
/* 260 */     char[] buf = new char[32];
/* 261 */     int count = 0;
/* 262 */     boolean wasFirst = true;
/*     */     
/*     */     public Object getResult() {
/* 265 */       return new String(this.buf, 0, this.count);
/*     */     }
/*     */     
/*     */     public void visit(Command command) {
/* 269 */       if (this.wasFirst) {
/* 270 */         append(command.getKey());
/* 271 */         this.wasFirst = false;
/*     */       } else {
/* 273 */         append(" ");
/* 274 */         append(command.getKey());
/*     */       }
/*     */     }
/*     */     
/*     */     private void expandCapacity(int minimumCapacity) {
/* 279 */       int newCapacity = (this.buf.length + 1) * 2;
/* 280 */       if (newCapacity < 0) {
/* 281 */         newCapacity = Integer.MAX_VALUE;
/* 282 */       } else if (minimumCapacity > newCapacity) {
/* 283 */         newCapacity = minimumCapacity;
/*     */       }
/* 285 */       char[] copy = new char[newCapacity];
/* 286 */       System.arraycopy(this.buf, 0, copy, 0, Math.min(this.buf.length, newCapacity));
/*     */       
/*     */ 
/* 289 */       this.buf = copy;
/*     */     }
/*     */     
/*     */     private void append(String str) {
/* 293 */       int len = str.length();
/* 294 */       if (len == 0)
/* 295 */         return;
/* 296 */       int newCount = this.count + len;
/* 297 */       if (newCount > this.buf.length)
/* 298 */         expandCapacity(newCount);
/* 299 */       str.getChars(0, len, this.buf, this.count);
/* 300 */       this.count = newCount;
/*     */     }
/*     */     
/*     */ 
/*     */     public void finish() {}
/*     */   }
/*     */   
/*     */ 
/*     */   private static class BinaryGetQCollector
/*     */     implements Optimizer.CommandCollector
/*     */   {
/* 311 */     LinkedList<IoBuffer> bufferList = new LinkedList();
/*     */     int totalBytes;
/*     */     Command prevCommand;
/*     */     
/*     */     public Object getResult() {
/* 316 */       byte[] buf = new byte[this.totalBytes];
/* 317 */       int offset = 0;
/* 318 */       for (IoBuffer buffer : this.bufferList) {
/* 319 */         byte[] ba = buffer.array();
/* 320 */         System.arraycopy(ba, 0, buf, offset, ba.length);
/* 321 */         offset += ba.length;
/*     */       }
/* 323 */       BinaryGetMultiCommand resultCommand = new BinaryGetMultiCommand(null, CommandType.GET_MANY, new CountDownLatch(1));
/*     */       
/* 325 */       resultCommand.setIoBuffer(IoBuffer.wrap(buf));
/* 326 */       return resultCommand;
/*     */     }
/*     */     
/*     */     public void visit(Command command)
/*     */     {
/* 331 */       if (this.prevCommand != null)
/*     */       {
/* 333 */         Command getqCommand = new BinaryGetCommand(this.prevCommand.getKey(), this.prevCommand.getKeyBytes(), null, null, OpCode.GET_KEY_QUIETLY, true);
/*     */         
/*     */ 
/* 336 */         getqCommand.encode();
/* 337 */         this.totalBytes += getqCommand.getIoBuffer().remaining();
/* 338 */         this.bufferList.add(getqCommand.getIoBuffer());
/*     */       }
/* 340 */       this.prevCommand = command;
/*     */     }
/*     */     
/*     */ 
/*     */     public void finish()
/*     */     {
/* 346 */       Command lastGetKCommand = new BinaryGetCommand(this.prevCommand.getKey(), this.prevCommand.getKeyBytes(), CommandType.GET_ONE, new CountDownLatch(1), OpCode.GET_KEY, false);
/*     */       
/*     */ 
/*     */ 
/* 350 */       lastGetKCommand.encode();
/* 351 */       this.bufferList.add(lastGetKCommand.getIoBuffer());
/* 352 */       this.totalBytes += lastGetKCommand.getIoBuffer().remaining();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private final Command mergeGetCommands(Command currentCmd, Queue writeQueue, Queue<Command> executingCmds, CommandType expectedCommandType)
/*     */   {
/* 361 */     Map<Object, Command> mergeCommands = null;
/* 362 */     int mergeCount = 1;
/* 363 */     CommandCollector commandCollector = creatCommandCollector();
/* 364 */     currentCmd.setStatus(OperationStatus.WRITING);
/*     */     
/* 366 */     commandCollector.visit(currentCmd);
/* 367 */     while (mergeCount < this.mergeFactor) {
/* 368 */       Command nextCmd = (Command)writeQueue.peek();
/* 369 */       if (nextCmd == null) {
/*     */         break;
/*     */       }
/* 372 */       if (nextCmd.isCancel()) {
/* 373 */         writeQueue.remove();
/*     */       }
/*     */       else {
/* 376 */         if (nextCmd.getCommandType() != expectedCommandType) break;
/* 377 */         if (mergeCommands == null) {
/* 378 */           mergeCommands = new HashMap(this.mergeFactor / 2);
/*     */           
/* 380 */           mergeCommands.put(currentCmd.getKey(), currentCmd);
/*     */         }
/* 382 */         if (log.isDebugEnabled()) {
/* 383 */           log.debug("Merge get command:" + nextCmd.toString());
/*     */         }
/* 385 */         nextCmd.setStatus(OperationStatus.WRITING);
/* 386 */         Command removedCommand = (Command)writeQueue.remove();
/*     */         
/* 388 */         if (mergeCommands.containsKey(removedCommand.getKey())) {
/* 389 */           AssocCommandAware mergedGetCommand = (AssocCommandAware)mergeCommands.get(removedCommand.getKey());
/*     */           
/* 391 */           if (mergedGetCommand.getAssocCommands() == null) {
/* 392 */             mergedGetCommand.setAssocCommands(new ArrayList(5));
/*     */           }
/*     */           
/* 395 */           mergedGetCommand.getAssocCommands().add(removedCommand);
/*     */         } else {
/* 397 */           commandCollector.visit(nextCmd);
/* 398 */           mergeCommands.put(removedCommand.getKey(), removedCommand);
/*     */         }
/* 400 */         mergeCount++;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 405 */     commandCollector.finish();
/* 406 */     if (mergeCount == 1) {
/* 407 */       return currentCmd;
/*     */     }
/* 409 */     if (log.isDebugEnabled()) {
/* 410 */       log.debug("Merge optimieze:merge " + mergeCount + " get commands");
/*     */     }
/*     */     
/* 413 */     return newMergedCommand(mergeCommands, mergeCount, commandCollector, expectedCommandType);
/*     */   }
/*     */   
/*     */ 
/*     */   private CommandCollector creatCommandCollector()
/*     */   {
/* 419 */     CommandCollector commandCollector = null;
/* 420 */     if (this.protocol == Protocol.Text) {
/* 421 */       commandCollector = new KeyStringCollector();
/*     */     } else {
/* 423 */       commandCollector = new BinaryGetQCollector(null);
/*     */     }
/* 425 */     return commandCollector;
/*     */   }
/*     */   
/*     */ 
/*     */   private Command newMergedCommand(Map<Object, Command> mergeCommands, int mergeCount, CommandCollector commandCollector, CommandType commandType)
/*     */   {
/* 431 */     if (this.protocol == Protocol.Text) {
/* 432 */       String resultKey = (String)commandCollector.getResult();
/*     */       
/* 434 */       byte[] keyBytes = ByteUtils.getBytes(resultKey);
/* 435 */       byte[] cmdBytes = commandType == CommandType.GET_ONE ? Constants.GET : Constants.GETS;
/*     */       
/* 437 */       byte[] buf = new byte[cmdBytes.length + 3 + keyBytes.length];
/* 438 */       ByteUtils.setArguments(buf, 0, new Object[] { cmdBytes, keyBytes });
/* 439 */       TextGetOneCommand cmd = new TextGetOneCommand(resultKey, keyBytes, commandType, null);
/*     */       
/* 441 */       cmd.setMergeCommands(mergeCommands);
/* 442 */       cmd.setWriteFuture(new FutureImpl());
/* 443 */       cmd.setMergeCount(mergeCount);
/* 444 */       cmd.setIoBuffer(IoBuffer.wrap(buf));
/* 445 */       return cmd;
/*     */     }
/* 447 */     BinaryGetMultiCommand result = (BinaryGetMultiCommand)commandCollector.getResult();
/*     */     
/* 449 */     result.setMergeCount(mergeCount);
/* 450 */     result.setMergeCommands(mergeCommands);
/* 451 */     return result;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\Optimizer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */