/*     */ package net.rubyeye.xmemcached.utils;
/*     */ 
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.ArrayList;
/*     */ import java.util.LinkedHashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AddrUtil
/*     */ {
/*     */   public static Map<InetSocketAddress, InetSocketAddress> getAddressMap(String s)
/*     */   {
/*  50 */     if (s == null) {
/*  51 */       throw new NullPointerException("Null host list");
/*     */     }
/*  53 */     if (s.trim().equals("")) {
/*  54 */       throw new IllegalArgumentException("No hosts in list:  ``" + s + "''");
/*     */     }
/*     */     
/*  57 */     Map<InetSocketAddress, InetSocketAddress> result = new LinkedHashMap();
/*  58 */     for (String hosts : s.split(" ")) {
/*  59 */       String[] nodes = hosts.split(",");
/*     */       
/*  61 */       if (nodes.length < 1) {
/*  62 */         throw new IllegalArgumentException("Invalid server ``" + hosts + "'' in list:  " + s);
/*     */       }
/*     */       
/*  65 */       String mainHost = nodes[0];
/*  66 */       InetSocketAddress mainAddress = getInetSocketAddress(s, mainHost);
/*  67 */       if (nodes.length >= 2) {
/*  68 */         InetSocketAddress standByAddress = getInetSocketAddress(s, nodes[1]);
/*     */         
/*  70 */         result.put(mainAddress, standByAddress);
/*     */       } else {
/*  72 */         result.put(mainAddress, null);
/*     */       }
/*     */     }
/*     */     
/*  76 */     assert (!result.isEmpty()) : "No addrs found";
/*  77 */     return result;
/*     */   }
/*     */   
/*     */   private static InetSocketAddress getInetSocketAddress(String s, String mainHost)
/*     */   {
/*  82 */     int finalColon = mainHost.lastIndexOf(':');
/*  83 */     if (finalColon < 1) {
/*  84 */       throw new IllegalArgumentException("Invalid server ``" + mainHost + "'' in list:  " + s);
/*     */     }
/*     */     
/*     */ 
/*  88 */     String hostPart = mainHost.substring(0, finalColon);
/*  89 */     String portNum = mainHost.substring(finalColon + 1);
/*     */     
/*  91 */     InetSocketAddress mainAddress = new InetSocketAddress(hostPart, Integer.parseInt(portNum));
/*     */     
/*  93 */     return mainAddress;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static List<InetSocketAddress> getAddresses(String s)
/*     */   {
/* 103 */     if (s == null) {
/* 104 */       throw new NullPointerException("Null host list");
/*     */     }
/* 106 */     if (s.trim().equals("")) {
/* 107 */       throw new IllegalArgumentException("No hosts in list:  ``" + s + "''");
/*     */     }
/*     */     
/* 110 */     ArrayList<InetSocketAddress> addrs = new ArrayList();
/*     */     
/* 112 */     for (String hoststuff : s.split(" ")) {
/* 113 */       int finalColon = hoststuff.lastIndexOf(':');
/* 114 */       if (finalColon < 1) {
/* 115 */         throw new IllegalArgumentException("Invalid server ``" + hoststuff + "'' in list:  " + s);
/*     */       }
/*     */       
/*     */ 
/* 119 */       String hostPart = hoststuff.substring(0, finalColon);
/* 120 */       String portNum = hoststuff.substring(finalColon + 1);
/*     */       
/* 122 */       addrs.add(new InetSocketAddress(hostPart, Integer.parseInt(portNum)));
/*     */     }
/*     */     
/*     */ 
/* 126 */     assert (!addrs.isEmpty()) : "No addrs found";
/* 127 */     return addrs;
/*     */   }
/*     */   
/*     */   public static InetSocketAddress getOneAddress(String server) {
/* 131 */     if (server == null) {
/* 132 */       throw new NullPointerException("Null host");
/*     */     }
/* 134 */     if (server.trim().equals("")) {
/* 135 */       throw new IllegalArgumentException("No hosts in:  ``" + server + "''");
/*     */     }
/*     */     
/*     */ 
/* 139 */     int finalColon = server.lastIndexOf(':');
/* 140 */     if (finalColon < 1) {
/* 141 */       throw new IllegalArgumentException("Invalid server ``" + server + "''");
/*     */     }
/*     */     
/*     */ 
/* 145 */     String hostPart = server.substring(0, finalColon);
/* 146 */     String portNum = server.substring(finalColon + 1);
/* 147 */     return new InetSocketAddress(hostPart, Integer.parseInt(portNum));
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\utils\AddrUtil.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */