/*     */ package com.google.code.yanf4j.core.impl;
/*     */ 
/*     */ import java.util.concurrent.CancellationException;
/*     */ import java.util.concurrent.ExecutionException;
/*     */ import java.util.concurrent.Future;
/*     */ import java.util.concurrent.TimeUnit;
/*     */ import java.util.concurrent.TimeoutException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class FutureImpl<R>
/*     */   implements Future<R>
/*     */ {
/*     */   private final Object sync;
/*     */   private boolean isDone;
/*     */   private boolean isCancelled;
/*     */   private Throwable failure;
/*     */   protected R result;
/*     */   
/*     */   public FutureImpl()
/*     */   {
/*  51 */     this(new Object());
/*     */   }
/*     */   
/*     */   public FutureImpl(Object sync) {
/*  55 */     this.sync = sync;
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public R getResult()
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: getfield 4	com/google/code/yanf4j/core/impl/FutureImpl:sync	Ljava/lang/Object;
/*     */     //   4: dup
/*     */     //   5: astore_1
/*     */     //   6: monitorenter
/*     */     //   7: aload_0
/*     */     //   8: getfield 5	com/google/code/yanf4j/core/impl/FutureImpl:result	Ljava/lang/Object;
/*     */     //   11: aload_1
/*     */     //   12: monitorexit
/*     */     //   13: areturn
/*     */     //   14: astore_2
/*     */     //   15: aload_1
/*     */     //   16: monitorexit
/*     */     //   17: aload_2
/*     */     //   18: athrow
/*     */     // Line number table:
/*     */     //   Java source line #64	-> byte code offset #0
/*     */     //   Java source line #65	-> byte code offset #7
/*     */     //   Java source line #66	-> byte code offset #14
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	19	0	this	FutureImpl<R>
/*     */     //   5	11	1	Ljava/lang/Object;	Object
/*     */     //   14	4	2	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   7	13	14	finally
/*     */     //   14	17	14	finally
/*     */   }
/*     */   
/*     */   public void setResult(R result)
/*     */   {
/*  76 */     synchronized (this.sync) {
/*  77 */       this.result = result;
/*  78 */       notifyHaveResult();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public boolean cancel(boolean mayInterruptIfRunning)
/*     */   {
/*  86 */     synchronized (this.sync) {
/*  87 */       this.isCancelled = true;
/*  88 */       notifyHaveResult();
/*  89 */       return true;
/*     */     }
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public boolean isCancelled()
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: getfield 4	com/google/code/yanf4j/core/impl/FutureImpl:sync	Ljava/lang/Object;
/*     */     //   4: dup
/*     */     //   5: astore_1
/*     */     //   6: monitorenter
/*     */     //   7: aload_0
/*     */     //   8: getfield 7	com/google/code/yanf4j/core/impl/FutureImpl:isCancelled	Z
/*     */     //   11: aload_1
/*     */     //   12: monitorexit
/*     */     //   13: ireturn
/*     */     //   14: astore_2
/*     */     //   15: aload_1
/*     */     //   16: monitorexit
/*     */     //   17: aload_2
/*     */     //   18: athrow
/*     */     // Line number table:
/*     */     //   Java source line #97	-> byte code offset #0
/*     */     //   Java source line #98	-> byte code offset #7
/*     */     //   Java source line #99	-> byte code offset #14
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	19	0	this	FutureImpl<R>
/*     */     //   5	11	1	Ljava/lang/Object;	Object
/*     */     //   14	4	2	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   7	13	14	finally
/*     */     //   14	17	14	finally
/*     */   }
/*     */   
/*     */   /* Error */
/*     */   public boolean isDone()
/*     */   {
/*     */     // Byte code:
/*     */     //   0: aload_0
/*     */     //   1: getfield 4	com/google/code/yanf4j/core/impl/FutureImpl:sync	Ljava/lang/Object;
/*     */     //   4: dup
/*     */     //   5: astore_1
/*     */     //   6: monitorenter
/*     */     //   7: aload_0
/*     */     //   8: getfield 8	com/google/code/yanf4j/core/impl/FutureImpl:isDone	Z
/*     */     //   11: aload_1
/*     */     //   12: monitorexit
/*     */     //   13: ireturn
/*     */     //   14: astore_2
/*     */     //   15: aload_1
/*     */     //   16: monitorexit
/*     */     //   17: aload_2
/*     */     //   18: athrow
/*     */     // Line number table:
/*     */     //   Java source line #106	-> byte code offset #0
/*     */     //   Java source line #107	-> byte code offset #7
/*     */     //   Java source line #108	-> byte code offset #14
/*     */     // Local variable table:
/*     */     //   start	length	slot	name	signature
/*     */     //   0	19	0	this	FutureImpl<R>
/*     */     //   5	11	1	Ljava/lang/Object;	Object
/*     */     //   14	4	2	localObject1	Object
/*     */     // Exception table:
/*     */     //   from	to	target	type
/*     */     //   7	13	14	finally
/*     */     //   14	17	14	finally
/*     */   }
/*     */   
/*     */   public R get()
/*     */     throws InterruptedException, ExecutionException
/*     */   {
/* 115 */     synchronized (this.sync)
/*     */     {
/* 117 */       if (this.isDone) {
/* 118 */         if (this.isCancelled)
/* 119 */           throw new CancellationException();
/* 120 */         if (this.failure != null)
/* 121 */           throw new ExecutionException(this.failure);
/* 122 */         if (this.result != null) {
/* 123 */           return (R)this.result;
/*     */         }
/*     */       }
/*     */       
/* 127 */       this.sync.wait();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public R get(long timeout, TimeUnit unit)
/*     */     throws InterruptedException, ExecutionException, TimeoutException
/*     */   {
/* 137 */     long startTime = System.currentTimeMillis();
/* 138 */     long timeoutMillis = TimeUnit.MILLISECONDS.convert(timeout, unit);
/* 139 */     synchronized (this.sync)
/*     */     {
/* 141 */       if (this.isDone) {
/* 142 */         if (this.isCancelled)
/* 143 */           throw new CancellationException();
/* 144 */         if (this.failure != null)
/* 145 */           throw new ExecutionException(this.failure);
/* 146 */         if (this.result != null) {
/* 147 */           return (R)this.result;
/*     */         }
/* 149 */       } else if (System.currentTimeMillis() - startTime > timeoutMillis) {
/* 150 */         throw new TimeoutException();
/*     */       }
/*     */       
/* 153 */       this.sync.wait(timeoutMillis);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void failure(Throwable failure)
/*     */   {
/* 165 */     synchronized (this.sync) {
/* 166 */       this.failure = failure;
/* 167 */       notifyHaveResult();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected void notifyHaveResult()
/*     */   {
/* 175 */     this.isDone = true;
/* 176 */     this.sync.notifyAll();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\core\impl\FutureImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */