package com.jaspersoft.jasperserver.api.engine.scheduling.service;

import com.jaspersoft.jasperserver.api.JasperServerAPI;
import com.jaspersoft.jasperserver.api.common.domain.ExecutionContext;
import com.jaspersoft.jasperserver.api.common.domain.ValidationErrors;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJob;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobIdHolder;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobRuntimeInformation;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobSummary;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.reportjobmodel.ReportJobModel;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.reportjobmodel.ReportJobModel.ReportJobSortType;
import java.util.Date;
import java.util.List;

@JasperServerAPI
public abstract interface ReportSchedulingService
{
  public abstract ReportJob scheduleJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob);
  
  public abstract List<ReportJob> scheduleJobsOnceNow(ExecutionContext paramExecutionContext, List<ReportJob> paramList);
  
  public abstract List<ReportJobIdHolder> scheduleJobsOnceNowById(ExecutionContext paramExecutionContext, List<ReportJobIdHolder> paramList);
  
  public abstract void updateScheduledJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob)
    throws ReportJobNotFoundException;
  
  public abstract List<ReportJobIdHolder> updateScheduledJobsByID(ExecutionContext paramExecutionContext, List<ReportJobIdHolder> paramList, ReportJobModel paramReportJobModel, boolean paramBoolean)
    throws TriggerTypeMismatchException, ReportJobNotFoundException, DuplicateOutputLocationException;
  
  public abstract List<ReportJob> updateScheduledJobs(ExecutionContext paramExecutionContext, List<ReportJob> paramList, ReportJobModel paramReportJobModel, boolean paramBoolean)
    throws TriggerTypeMismatchException, DuplicateOutputLocationException;
  
  /**
   * @deprecated
   */
  public abstract List getScheduledJobs(ExecutionContext paramExecutionContext, String paramString);
  
  /**
   * @deprecated
   */
  public abstract List getScheduledJobs(ExecutionContext paramExecutionContext);
  
  public abstract List<ReportJobSummary> getScheduledJobSummaries(ExecutionContext paramExecutionContext, String paramString);
  
  public abstract List<ReportJobSummary> getScheduledJobSummaries(ExecutionContext paramExecutionContext);
  
  public abstract List<ReportJobSummary> getScheduledJobSummaries(ExecutionContext paramExecutionContext, ReportJobModel paramReportJobModel, int paramInt1, int paramInt2, ReportJobModel.ReportJobSortType paramReportJobSortType, boolean paramBoolean);
  
  public abstract List<ReportJobSummary> getJobsByNextFireTime(ExecutionContext paramExecutionContext, List<ReportJob> paramList, Date paramDate1, Date paramDate2, List<Byte> paramList1);
  
  public abstract ReportJobRuntimeInformation getJobRuntimeInformation(ExecutionContext paramExecutionContext, long paramLong);
  
  public abstract void removeScheduledJob(ExecutionContext paramExecutionContext, long paramLong);
  
  public abstract void removeScheduledJobs(ExecutionContext paramExecutionContext, long[] paramArrayOfLong);
  
  public abstract ReportJob getScheduledJob(ExecutionContext paramExecutionContext, long paramLong);
  
  public abstract ValidationErrors validateJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob);
  
  public abstract void pause(List<ReportJob> paramList, boolean paramBoolean);
  
  public abstract void resume(List<ReportJob> paramList, boolean paramBoolean);
  
  public abstract void pauseById(List<ReportJobIdHolder> paramList, boolean paramBoolean);
  
  public abstract void resumeById(List<ReportJobIdHolder> paramList, boolean paramBoolean);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\service\ReportSchedulingService.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */