/*    */ package com.netapp.asup.data.function.aggregation;
/*    */ 
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ConcatFieldAggregator
/*    */   extends Aggregator<String>
/*    */ {
/*    */   private final String delimiter;
/*    */   private final Aggregator<String> aggregator;
/*    */   private static final String DEFAULT_DELIMITER = ";";
/*    */   
/*    */   public ConcatFieldAggregator(AggregationType aggregationType, GenericRecord aggregationField, Aggregator<?> aggregator)
/*    */     throws ARMAException
/*    */   {
/* 22 */     super(aggregationType, aggregationField);
/* 23 */     this.aggregator = aggregator;
/* 24 */     if (this.options != null) {
/* 25 */       Utf8 delimiter = (Utf8)this.options.get(new Utf8(AggregationInputImpl.Options.DELIMITER.getName()));
/* 26 */       if (delimiter != null) {
/* 27 */         this.delimiter = delimiter.toString();
/*    */       } else {
/* 29 */         this.delimiter = ";";
/*    */       }
/*    */     } else {
/* 32 */       this.delimiter = ";";
/*    */     }
/*    */   }
/*    */   
/*    */   public String getResult()
/*    */   {
/* 38 */     if (this.delimiter.length() > 0) {
/* 39 */       return this.aggregator.getResult().substring(this.delimiter.length());
/*    */     }
/* 41 */     return this.aggregator.getResult();
/*    */   }
/*    */   
/*    */ 
/*    */   public void compute(ARMAObjectInstance instance)
/*    */     throws ARMAException
/*    */   {
/* 48 */     this.aggregator.compute(this.delimiter);
/* 49 */     this.aggregator.compute(instance);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\aggregation\ConcatFieldAggregator.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */