/*    */ package com.netapp.asup.metamodel;
/*    */ 
/*    */ import java.util.Collections;
/*    */ import java.util.HashMap;
/*    */ import java.util.Iterator;
/*    */ import java.util.Map;
/*    */ import java.util.Set;
/*    */ import prefuse.data.Graph;
/*    */ import prefuse.data.Node;
/*    */ import prefuse.data.Tree;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class MetaModel
/*    */ {
/*    */   private static final String NODE_ID = "nodeId";
/*    */   private final Graph graph;
/*    */   private final Map<String, NodeObject> nodeMap;
/*    */   private final NodeObject rootObject;
/*    */   private final String metamodelVersion;
/*    */   
/*    */   public String getMetamodelVersion()
/*    */   {
/* 27 */     return this.metamodelVersion;
/*    */   }
/*    */   
/*    */   public Graph getGraph() {
/* 31 */     return this.graph;
/*    */   }
/*    */   
/*    */   public MetaModel(Graph graph, String metamodelVersion) {
/* 35 */     this.graph = graph;
/* 36 */     this.nodeMap = Collections.synchronizedMap(new HashMap());
/* 37 */     populateNodeMap(graph);
/* 38 */     this.rootObject = ((NodeObject)this.nodeMap.get(graph.getSpanningTree().getRoot().getString("nodeId")));
/* 39 */     this.metamodelVersion = metamodelVersion;
/*    */   }
/*    */   
/*    */   private void populateNodeMap(Graph graph)
/*    */   {
/* 44 */     Iterator<Node> nodes = graph.nodes();
/* 45 */     Node node = null;
/* 46 */     while (nodes.hasNext()) {
/* 47 */       node = (Node)nodes.next();
/* 48 */       String nodeName = node.getString("nodeId");
/* 49 */       NodeObject nodeObject = (NodeObject)this.nodeMap.get(nodeName);
/*    */       
/* 51 */       if (nodeObject == null) {
/* 52 */         nodeObject = new NodeObject(this, node, true);
/* 53 */         this.nodeMap.put(nodeName, nodeObject);
/* 54 */       } else if (nodeObject.getRelationMap().isEmpty()) {
/* 55 */         nodeObject.populateRelationMap(node);
/*    */       }
/*    */       
/* 58 */       nodeObject.updateVirtualPCRNames();
/*    */     }
/*    */   }
/*    */   
/*    */   public final void addToNodeMap(NodeObject nodeObject) {
/* 63 */     this.nodeMap.put(nodeObject.getName(), nodeObject);
/*    */   }
/*    */   
/*    */   public NodeObject getNode(String name) {
/* 67 */     return (NodeObject)this.nodeMap.get(name);
/*    */   }
/*    */   
/*    */   public Set<String> getAllNodeNames() {
/* 71 */     return this.nodeMap.keySet();
/*    */   }
/*    */   
/*    */   public NodeObject getRoot() {
/* 75 */     return this.rootObject;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\metamodel\MetaModel.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */