/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import javax.activation.DataHandler;
/*     */ import javax.xml.bind.ValidationEventHandler;
/*     */ import javax.xml.bind.attachment.AttachmentUnmarshaller;
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class MTOMDecorator
/*     */   implements XmlVisitor
/*     */ {
/*     */   private final XmlVisitor next;
/*     */   private final AttachmentUnmarshaller au;
/*     */   private UnmarshallerImpl parent;
/*  25 */   private final Base64Data base64data = new Base64Data();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private boolean inXopInclude;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private boolean followXop;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public MTOMDecorator(UnmarshallerImpl parent, XmlVisitor next, AttachmentUnmarshaller au)
/*     */   {
/*  43 */     this.parent = parent;
/*  44 */     this.next = next;
/*  45 */     this.au = au;
/*     */   }
/*     */   
/*     */   public void startDocument(LocatorEx loc, NamespaceContext nsContext) throws SAXException {
/*  49 */     this.next.startDocument(loc, nsContext);
/*     */   }
/*     */   
/*     */   public void endDocument() throws SAXException {
/*  53 */     this.next.endDocument();
/*     */   }
/*     */   
/*     */   public void startElement(TagName tagName) throws SAXException {
/*  57 */     if ((tagName.local == "Include") && (tagName.uri == "http://www.w3.org/2004/08/xop/include"))
/*     */     {
/*  59 */       String href = tagName.atts.getValue("href");
/*  60 */       DataHandler attachment = this.au.getAttachmentAsDataHandler(href);
/*  61 */       if (attachment == null)
/*     */       {
/*  63 */         this.parent.getEventHandler().handleEvent(null);
/*     */       }
/*     */       
/*  66 */       this.base64data.set(attachment);
/*  67 */       this.next.text(this.base64data);
/*  68 */       this.inXopInclude = true;
/*  69 */       this.followXop = true;
/*     */     } else {
/*  71 */       this.next.startElement(tagName);
/*     */     }
/*     */   }
/*     */   
/*  75 */   public void endElement(TagName tagName) throws SAXException { if (this.inXopInclude)
/*     */     {
/*  77 */       this.inXopInclude = false;
/*  78 */       this.followXop = true;
/*  79 */       return;
/*     */     }
/*  81 */     this.next.endElement(tagName);
/*     */   }
/*     */   
/*     */   public void startPrefixMapping(String prefix, String nsUri) throws SAXException {
/*  85 */     this.next.startPrefixMapping(prefix, nsUri);
/*     */   }
/*     */   
/*     */   public void endPrefixMapping(String prefix) throws SAXException {
/*  89 */     this.next.endPrefixMapping(prefix);
/*     */   }
/*     */   
/*     */   public void text(CharSequence pcdata) throws SAXException {
/*  93 */     if (!this.followXop) {
/*  94 */       this.next.text(pcdata);
/*     */     } else
/*  96 */       this.followXop = false;
/*     */   }
/*     */   
/*     */   public UnmarshallingContext getContext() {
/* 100 */     return this.next.getContext();
/*     */   }
/*     */   
/*     */   public XmlVisitor.TextPredictor getPredictor() {
/* 104 */     return this.next.getPredictor();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\MTOMDecorator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */