/*     */ package org.codehaus.commons.compiler;
/*     */ 
/*     */ import java.io.File;
/*     */ import java.io.FileInputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.InputStreamReader;
/*     */ import java.io.Reader;
/*     */ import java.io.StringReader;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Cookable
/*     */   implements ICookable
/*     */ {
/*     */   public abstract void cook(String paramString, Reader paramReader)
/*     */     throws CompileException, IOException;
/*     */   
/*     */   public final void cook(Reader r)
/*     */     throws CompileException, IOException
/*     */   {
/*  39 */     cook(null, r);
/*     */   }
/*     */   
/*     */   public final void cook(InputStream is) throws CompileException, IOException {
/*  43 */     cook(null, is);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void cook(String optionalFileName, InputStream is)
/*     */     throws CompileException, IOException
/*     */   {
/*  50 */     cook(optionalFileName, is, null);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void cook(InputStream is, String optionalEncoding)
/*     */     throws CompileException, IOException
/*     */   {
/*  57 */     cook(optionalEncoding == null ? new InputStreamReader(is) : new InputStreamReader(is, optionalEncoding));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public final void cook(String optionalFileName, InputStream is, String optionalEncoding)
/*     */     throws CompileException, IOException
/*     */   {
/*  65 */     cook(optionalFileName, optionalEncoding == null ? new InputStreamReader(is) : new InputStreamReader(is, optionalEncoding));
/*     */   }
/*     */   
/*     */ 
/*     */   public void cook(String s)
/*     */     throws CompileException
/*     */   {
/*  72 */     cook((String)null, s);
/*     */   }
/*     */   
/*     */   public void cook(String optionalFileName, String s)
/*     */     throws CompileException
/*     */   {
/*     */     try
/*     */     {
/*  80 */       cook(optionalFileName, new StringReader(s));
/*     */     } catch (IOException ioe) {
/*  82 */       ioe.printStackTrace();
/*  83 */       throw new RuntimeException("SNO: StringReader throws IOException");
/*     */     }
/*     */   }
/*     */   
/*     */   public final void cookFile(File file) throws CompileException, IOException {
/*  88 */     cookFile(file, null);
/*     */   }
/*     */   
/*     */ 
/*     */   public final void cookFile(File file, String optionalEncoding)
/*     */     throws CompileException, IOException
/*     */   {
/*  95 */     InputStream is = new FileInputStream(file);
/*     */     try {
/*  97 */       cook(file.getAbsolutePath(), optionalEncoding == null ? new InputStreamReader(is) : new InputStreamReader(is, optionalEncoding));
/*     */       
/*     */ 
/*     */ 
/* 101 */       is.close();
/* 102 */       is = null; return;
/*     */     } finally {
/* 104 */       if (is != null) try { is.close();
/*     */         } catch (IOException ex) {}
/*     */     }
/*     */   }
/*     */   
/* 109 */   public final void cookFile(String fileName) throws CompileException, IOException { cookFile(fileName, null); }
/*     */   
/*     */ 
/*     */ 
/*     */   public final void cookFile(String fileName, String optionalEncoding)
/*     */     throws CompileException, IOException
/*     */   {
/* 116 */     cookFile(new File(fileName), optionalEncoding);
/*     */   }
/*     */   
/*     */ 
/*     */   public static String readString(Reader r)
/*     */     throws IOException
/*     */   {
/* 123 */     StringBuffer sb = new StringBuffer();
/* 124 */     char[] ca = new char['က'];
/*     */     for (;;) {
/* 126 */       int count = r.read(ca);
/* 127 */       if (count == -1) break;
/* 128 */       sb.append(ca, 0, count);
/*     */     }
/* 130 */     String s = sb.toString();
/* 131 */     return s;
/*     */   }
/*     */   
/*     */   public abstract void setDebuggingInformation(boolean paramBoolean1, boolean paramBoolean2, boolean paramBoolean3);
/*     */   
/*     */   public abstract void setParentClassLoader(ClassLoader paramClassLoader);
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\commons\compiler\Cookable.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */