/*     */ package org.codehaus.jackson.map.deser;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import org.codehaus.jackson.map.AnnotationIntrospector;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class EnumResolver<T extends Enum<T>>
/*     */ {
/*     */   protected final Class<T> _enumClass;
/*     */   protected final T[] _enums;
/*     */   protected final HashMap<String, T> _enumsById;
/*     */   
/*     */   private EnumResolver(Class<T> enumClass, T[] enums, HashMap<String, T> map)
/*     */   {
/*  21 */     this._enumClass = enumClass;
/*  22 */     this._enums = enums;
/*  23 */     this._enumsById = map;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static <ET extends Enum<ET>> EnumResolver<ET> constructFor(Class<ET> enumCls, AnnotationIntrospector ai)
/*     */   {
/*  32 */     ET[] enumValues = (Enum[])enumCls.getEnumConstants();
/*  33 */     if (enumValues == null) {
/*  34 */       throw new IllegalArgumentException("No enum constants for class " + enumCls.getName());
/*     */     }
/*  36 */     HashMap<String, ET> map = new HashMap();
/*  37 */     for (ET e : enumValues) {
/*  38 */       map.put(ai.findEnumValue(e), e);
/*     */     }
/*  40 */     return new EnumResolver(enumCls, enumValues, map);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static <ET extends Enum<ET>> EnumResolver<ET> constructUsingToString(Class<ET> enumCls)
/*     */   {
/*  51 */     ET[] enumValues = (Enum[])enumCls.getEnumConstants();
/*  52 */     HashMap<String, ET> map = new HashMap();
/*     */     
/*  54 */     int i = enumValues.length; for (;;) { i--; if (i < 0) break;
/*  55 */       ET e = enumValues[i];
/*  56 */       map.put(e.toString(), e);
/*     */     }
/*  58 */     return new EnumResolver(enumCls, enumValues, map);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static EnumResolver<?> constructUnsafe(Class<?> rawEnumCls, AnnotationIntrospector ai)
/*     */   {
/*  71 */     Class<Enum> enumCls = rawEnumCls;
/*  72 */     return constructFor(enumCls, ai);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static EnumResolver<?> constructUnsafeUsingToString(Class<?> rawEnumCls)
/*     */   {
/*  85 */     Class<Enum> enumCls = rawEnumCls;
/*  86 */     return constructUsingToString(enumCls);
/*     */   }
/*     */   
/*     */   public T findEnum(String key)
/*     */   {
/*  91 */     return (Enum)this._enumsById.get(key);
/*     */   }
/*     */   
/*     */   public T getEnum(int index)
/*     */   {
/*  96 */     if ((index < 0) || (index >= this._enums.length)) {
/*  97 */       return null;
/*     */     }
/*  99 */     return this._enums[index];
/*     */   }
/*     */   
/* 102 */   public Class<T> getEnumClass() { return this._enumClass; }
/*     */   
/* 104 */   public int lastValidIndex() { return this._enums.length - 1; }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\deser\EnumResolver.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */