/*    */ package org.codehaus.janino;
/*    */ 
/*    */ import java.security.AccessController;
/*    */ import java.security.PrivilegedAction;
/*    */ import org.codehaus.commons.compiler.AbstractCompilerFactory;
/*    */ import org.codehaus.commons.compiler.AbstractJavaSourceClassLoader;
/*    */ import org.codehaus.commons.compiler.IClassBodyEvaluator;
/*    */ import org.codehaus.commons.compiler.IExpressionEvaluator;
/*    */ import org.codehaus.commons.compiler.IScriptEvaluator;
/*    */ import org.codehaus.commons.compiler.ISimpleCompiler;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class CompilerFactory
/*    */   extends AbstractCompilerFactory
/*    */ {
/*    */   public String getId()
/*    */   {
/* 36 */     return "org.codehaus.janino";
/*    */   }
/*    */   
/*    */   public String getImplementationVersion() {
/* 40 */     return CompilerFactory.class.getPackage().getImplementationVersion();
/*    */   }
/*    */   
/*    */   public IExpressionEvaluator newExpressionEvaluator() {
/* 44 */     return new ExpressionEvaluator();
/*    */   }
/*    */   
/*    */   public IScriptEvaluator newScriptEvaluator() {
/* 48 */     return new ScriptEvaluator();
/*    */   }
/*    */   
/*    */   public IClassBodyEvaluator newClassBodyEvaluator() {
/* 52 */     return new ClassBodyEvaluator();
/*    */   }
/*    */   
/*    */   public ISimpleCompiler newSimpleCompiler() {
/* 56 */     return new SimpleCompiler();
/*    */   }
/*    */   
/*    */   public AbstractJavaSourceClassLoader newJavaSourceClassLoader() {
/* 60 */     (AbstractJavaSourceClassLoader)AccessController.doPrivileged(new PrivilegedAction() {
/*    */       public Object run() {
/* 62 */         return new JavaSourceClassLoader();
/*    */       }
/*    */     });
/*    */   }
/*    */   
/*    */   public AbstractJavaSourceClassLoader newJavaSourceClassLoader(ClassLoader parentClassLoader) {
/* 68 */     (AbstractJavaSourceClassLoader)AccessController.doPrivileged(new PrivilegedAction() { private final ClassLoader val$parentClassLoader;
/*    */       
/* 70 */       public Object run() { return new JavaSourceClassLoader(this.val$parentClassLoader); }
/*    */     });
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\CompilerFactory.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */