package prefuse.action.assignment;

import java.util.Map;
import prefuse.Visualization;
import prefuse.data.Table;
import prefuse.data.column.ColumnMetadata;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.VisualItem;

public class DataShapeAction
  extends ShapeAction
{
  protected String m_dataField;
  protected int[] m_palette;
  protected Map m_ordinalMap;
  
  public DataShapeAction(String paramString1, String paramString2)
  {
    super(paramString1);
    this.m_dataField = paramString2;
  }
  
  public DataShapeAction(String paramString1, String paramString2, int[] paramArrayOfInt)
  {
    super(paramString1);
    this.m_dataField = paramString2;
    this.m_palette = paramArrayOfInt;
  }
  
  public String getDataField()
  {
    return this.m_dataField;
  }
  
  public void setDataField(String paramString)
  {
    this.m_dataField = paramString;
  }
  
  public void run(double paramDouble)
  {
    TupleSet localTupleSet = this.m_vis.getGroup(this.m_group);
    if (!(localTupleSet instanceof Table)) {
      return;
    }
    Table localTable = (Table)localTupleSet;
    ColumnMetadata localColumnMetadata = localTable.getMetadata(this.m_dataField);
    this.m_ordinalMap = localColumnMetadata.getOrdinalMap();
    super.run(paramDouble);
  }
  
  public int getShape(VisualItem paramVisualItem)
  {
    Object localObject = paramVisualItem.get(this.m_dataField);
    int i = ((Integer)this.m_ordinalMap.get(localObject)).intValue();
    if (this.m_palette == null) {
      return i % 10;
    }
    return this.m_palette[(i % this.m_palette.length)];
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\assignment\DataShapeAction.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */