package prefuse.controls;

import java.awt.geom.Point2D;
import prefuse.Display;

public class AbstractZoomControl
  extends ControlAdapter
{
  public static final double DEFAULT_MIN_SCALE = 0.001D;
  public static final double DEFAULT_MAX_SCALE = 75.0D;
  protected static final int ZOOM = 0;
  protected static final int MIN_ZOOM = 1;
  protected static final int MAX_ZOOM = 2;
  protected static final int NO_ZOOM = 3;
  protected double m_minScale = 0.001D;
  protected double m_maxScale = 75.0D;
  protected boolean m_zoomOverItem = true;
  
  protected int zoom(Display paramDisplay, Point2D paramPoint2D, double paramDouble, boolean paramBoolean)
  {
    if (paramDisplay.isTranformInProgress()) {
      return 3;
    }
    double d1 = paramDisplay.getScale();
    double d2 = d1 * paramDouble;
    int i = 0;
    if (d2 < this.m_minScale)
    {
      paramDouble = this.m_minScale / d1;
      i = 1;
    }
    else if (d2 > this.m_maxScale)
    {
      paramDouble = this.m_maxScale / d1;
      i = 2;
    }
    if (paramBoolean) {
      paramDisplay.zoomAbs(paramPoint2D, paramDouble);
    } else {
      paramDisplay.zoom(paramPoint2D, paramDouble);
    }
    paramDisplay.repaint();
    return i;
  }
  
  public double getMaxScale()
  {
    return this.m_maxScale;
  }
  
  public void setMaxScale(double paramDouble)
  {
    this.m_maxScale = paramDouble;
  }
  
  public double getMinScale()
  {
    return this.m_minScale;
  }
  
  public void setMinScale(double paramDouble)
  {
    this.m_minScale = paramDouble;
  }
  
  public boolean isZoomOverItem()
  {
    return this.m_zoomOverItem;
  }
  
  public void setZoomOverItem(boolean paramBoolean)
  {
    this.m_zoomOverItem = paramBoolean;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\AbstractZoomControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */