package prefuse.data.parser;

import java.text.DateFormat;
import java.text.ParsePosition;

public class DateParser
  implements DataParser
{
  protected DateFormat m_dfmt;
  protected ParsePosition m_pos;
  
  public DateParser()
  {
    this(DateFormat.getDateInstance(3));
  }
  
  public DateParser(DateFormat paramDateFormat)
  {
    this.m_dfmt = paramDateFormat;
    this.m_pos = new ParsePosition(0);
  }
  
  public Class getType()
  {
    return java.sql.Date.class;
  }
  
  public boolean canParse(String paramString)
  {
    try
    {
      parseDate(paramString);
      return true;
    }
    catch (DataParseException localDataParseException) {}
    return false;
  }
  
  public Object parse(String paramString)
    throws DataParseException
  {
    return parseDate(paramString);
  }
  
  public java.sql.Date parseDate(String paramString)
    throws DataParseException
  {
    this.m_pos.setErrorIndex(0);
    this.m_pos.setIndex(0);
    java.sql.Date localDate = null;
    try
    {
      localDate = java.sql.Date.valueOf(paramString);
      this.m_pos.setIndex(paramString.length());
    }
    catch (IllegalArgumentException localIllegalArgumentException)
    {
      localDate = null;
    }
    if (localDate == null)
    {
      java.util.Date localDate1 = this.m_dfmt.parse(paramString, this.m_pos);
      if (localDate1 != null) {
        localDate = new java.sql.Date(localDate1.getTime());
      }
    }
    if ((localDate == null) || (this.m_pos.getIndex() < paramString.length())) {
      throw new DataParseException("Could not parse Date: " + paramString);
    }
    return localDate;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\parser\DateParser.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */